.TH PFTP 1L "GNU File Transfer Utilities" "FSF" \" -*- nroff -*-
.SH NAME
pftp \- fast data transfer program
.SH SYNOPSIS
.br
Server:
.B pftp
[portnumber] [OPTIONS]
.br
.br
Client:
.B pftp
[portnumber] [OPTIONS] [hostname] [files]
.BR
.SH DESCRIPTION
This manual page
documents the GNU version of
.BR pftp .
.BR pftp
transfers data from host to host.  All line feed characters contained
in file and directory names are transfered to underline characters.
There is no authorization mechanism necessary but possible.  Up to
255 connections are possible at a time.  If pftp is started by inetd
the number of connections is unlimited.  First the server has to be
started at the destination host with a port number in the range of
1025 and at least 32767.  The server may also be started as a daemon
by the internet daemon or by a normal user in the background.
Thereafter the client may send data to the port of the destination
host.  By default
.BR pftp
uses TCP based connections.  However you can also send UDP datagrams
to the server based just on UDP.
.BR pftp
supports unicast, broadcast, and multicast.  See section
.BR EXAMPLES
for further information.

.SS OPTIONS
.TP
.I "\-"
Hereby the client sends all data from standard input to the destination
host.  If the client and the server are started with this option, the
server sends all bytes to standard output.  If on the other hand the
server was started with this option, but the client sends regular files,
the server copies all files to disk.  If only the client was started with
the option, the server copies the received stream to a file called
.IR Stream.x .
.IR x
is an increasing number beginning at 1.  The client reads one character
at a time as well as the server, i.e. sending many characters with
`-' eats a lot of cpu time and might be slower (see `-b[NUM]').
.TP
.I "\-a"
Always overwrite existing files. (Server option only)
.TP
.I "\-aN1aN2..."
Seek the N1th offset from the beginning of the first file, the N2th offset
from the beginning of the second file etc.  If a file is incomplete
received then you may try to send just the missing part of the file, i.e.
N1 respectively N2 is the size of the incomplete file.  I suggest to
truncate the incomplete file by a several bytes at first.  Then start the
server in the appropriate directory and choose `a' when the server asks
you. (Client option only)
.TP
.I "\-ANUM"
On the Linux Operating system you can limit the number of clients
allowed at once to NUM.
.TP
.I "\-b[NUM]"
Same as `-' except that a string of size NUM is read and written at once.
.BR pftp
does not limit this value.  So whatever your system supports you may
set.  The default string size for `-b' is 4096.  Hereby as well as
when sending files the net buffer size defaults to 32768 unless
`-B[NUM]' is given on command line.
.TP
.I "\-bb"
Same as `-b32768'.
.TP
.I "\-B[NUM]"
Sets the maximum net buffer size, i.e. SO_SNDBUF resp. SO_RCVBUF (see
.BR setsockopt (2)),
specified by `NUM' or if `NUM' is omitted by the variable
.IR PFTPNETBUF
(see
.BR ENVIRONMENT ).
The default maximum net buffer size is 32768.  This applies to data
sent or received.  The net buffer size is not the window size, which
is determined by TCP in kernel space on the server side, though.  But
the bigger you set this size the bigger the window size mostly is
although the window size is dynamically determined.  The better your
network connection is the bigger the net buffer size can be (see also
"TCP/IP Network Administration", Second Edition by Craig Hunt, O'Reilly
& Associates, p. 20).
.TP
.I "\-BB"
Same as `-B65536'.
.TP
.I "\-c hostnames"
Connections are accepted from clients with specified host names only.
All other clients are simply refused. Host names can also be given
as numbers which are looked up in your
.BR pftp
resource file (see
.BR RESOURCES ).
If no host names are specified the environment variable
.IR PFTPCLIENTS
is read instead (see
.BR ENVIRONMENT ).
You may also specify domain names:  All client host names that begin
with a dot are supposed to be domain names.  By now this is only
support for TCP based connections.  (Server option only)
.TP
.I "\-d[=DIR]"
The daemon works just like the server started from inetd (see `-i' ).
There are just two differences:  First the daemon keeps running (see
.BR BUGS )
and second the daemon may be started by a normal user.  If your system
has shadow password you have to set the variable
.IR PFTPPASS
unless the daemon is running with root  privileges.
The client needs this option to send data to the daemon.
.TP
.I "\-e"
Create a normal Unix (MD5) password with crypt().  If you want to set
the variable
.IR PFTPPASS
you may need the password.
.TP
.I "\-f[n]"
Filter all files before sending them over the network, i.e. the
standard output of the filter on the client side is connected to the
standard input of the filter on the server side.  The filters are
specified by
.IR PFTPCFILTER
respectively
.IR PFTPSFILTER
(see
.BR ENVIRONMENT ).
(TCP based connections only)
.TP
.I "\-i[=DIR]"
Start
.BR pftp
from `/etc/inetd.conf' by inetd.  You do need a system pftp resource file
which is located in `/etc/pftp.conf'.  If there is no resource file the
connection is closed.  The following lines may be specified in
`/etc/inetd.conf' (see
.BR inetd (8))
and `/etc/services' (see
.BR services (5))
in order to start the
.BR pftp
server by inetd with the capability to copy files as well as
directories and to accept specified clients only:
.sp
.RS +1i
.ta 0.5i 1.0i
.nf
for `/etc/inetd.conf' (all on one line):
pftp stream  tcp  nowait  root
/usr/local/bin/pftp pftp -irc
.sp
for `/etc/services':
pftp     26/tcp
.fi
.RE
.sp
.TP
.I ""
At first
.BR pftp
reads the system resource file located in `/etc/pftp.conf' and gets the
user name and the number of the filter program to be used from the
client.  Both is send raw through the net,  i.e. a port sniffer may see
them.  Then
.BR pftp
starts two subprocesses and changes their setuid/setgid bits to
the user's setuid/setgid bits--root is denied by default (see
.BR PFTPNOROOT ).
Now the password is send filtered through the net.  Thus it is up to you
to decide which level of security you need.  The server changes the
directory to DIR if given by the client or to the user's home directory
and sets the environment variables `HOME' and `USER' appropriately.  The
user must have a
.BR pftp
resource file in his/her home directory from which the filter program is
to be read.
.sp
The client needs this option to send data to the server
started by inetd and to set the destination directory DIR which is set to
the remote user's home directory if =DIR is omitted.  The port
number is set to 26.  The port number found in the
.BR pftp
resource file is
ignored.  For security reasons the daemon does not accept streams.
.TP
.I "\-j"
Read file and directory (see `-r') names from standard input one file name
per line.  Options `-l', and `-[b]' are silently ignored.  (Client option
only)
.TP
.I "\-l"
List host names from file `.pftprc' and send files. Cannot be used in
standard input mode!  (Client option only)
.TP
.I "\-L"
Do not follow symbolic links.  The link names are temporaryly saved
in a file.  The file is sent after all other files have been sent.
On the target host this file is called `PFTP_MAKE_LINKS'.  It is
just a shell script file you may execute as such `./PFTP_MAKE_LINKS'
to automatically create all symbolic links.  The local temporary
file is removed after it was sent.  For secrurity reasons you may
also check the shell script before you execute it.  If no symbolic
links were found no PFTP_MAKE_LINKS file is sent.  (Client option only)
.TP
.I "\-m[NUM]"
Same as `-u[NUM] with all capabilities except that multicasting is
enabled.  So it is needed to send or receive multicasted datagrams unless
one of the other `-m' options is chosen.  All `-m' options imply this
option.  So you only need it to change the default payload length.  Be
sure that you enabled multicasting for your side, i.e.  the following
needs to be done on the Linux Operating System: 1) Enable multicasting
within your kernel sources options (Networking options ---> IP:
multicasting).  2) Set the appropriate route (route add -net 224.0.0.0
netmask 240.0.0.0 dev multicasted_interface).  If everything is fine you
should find `/proc/net/igmp' in your file system.  (See also the excellent
document: `HOWTO/Multicasting'.)
.TP
.I "\-mg GROUP"
Set the multicast group to GROUP.  In order to receive multicasted
datagrams you need to join a multicast group. (Server option only)
.TP
.I "\-mi IADDR"
Use the interface IADDR at your local host for sending respectively
receiving multicasted datagrams.  By default the kernel chooses an
interface for you.
.TP
.I "\-mtNUM"
Set the time to live (IPv4) respectively the hop limit (IPv6).  Defaults
to 1. (Client option only)
.TP
.I "\-ml"
By default pftp unsets looping back of datagrams.  Thus if you want to
receive back what you sent from your local host you will need this option.
(Client option only)
.TP
.I "\-M[=FILE]"
In combination with `-n' the message file FILE will be added to the data.
If =FILE is omitted: interactively edit a message file (see
.IR PFTPEDITOR ).
.TP
.I "\-N"
Peek for new data in the upload directory.
.TP
.I "\-n"
If no further options are given starts the simple
.BR pftp
file and directory manager.  Else: Send data to another user.  The other
user must have set the variable
.IR PFTPRECEIVE
to the absolute path of an upload directory (see
.BR ENVIRONMENT ).
On the remote host
.BR pftp
has to be started by inetd (see `-i') or run
as a daemon (see `-d').  This option is implied if something like this
.sp
.RS +1i
.ta 0.5i 1.0i
.nf
pftp user@remote_host files
.fi
.RE
.sp
.TP
.I ""
is given on command line.  The port is set to the default port 26.
.TP
.I "\-n=SUBJECT"
Same as `-n' but also add subject line SUBJECT to the data.
.TP
.I "\-nn"
Same as `-n' but interactively ask for a subject line and add that line
to the data.
.TP
.I "\-NUM"
Choose host NUM from host name list. (Client option only)
.TP
.I "\-p[NUM]"
This options works just like `-b[NUM]' except that all data received,
i.e. also files, are sent to standard output.  If `NUM' is omitted
standard output is unbuffered. (Server option only)
.TP
.I "\-pp"
Same as `-p32768'. (Server option only)
.TP
.I "\-P[NUM]"
Sets the datagram priority to NUM.  If `NUM' is omitted the value
defaults to 4. (IPv6 client option only)
.TP
.I "\-q"
Silent mode.  Unless a serious error occurs no output will be delivered.
By default all existing files are skipped.  If option `-a' is given on
command line all existing files are overwritten.  If the environment variable
.IR PFTPSLOG
is set to the absolute path of a log file, the server
logs all data normally written to stderr
(see
.BR ENVIRONMENT ).
This option was meant for shell skripts and the like.
You should use this option if you want to pipe output of
.BR pftp
into a pager otherwise
.BR pftp
resets its own terminal modes on exit.
.TP
.I "\-r"
If the server and the client are started with this option,
all files received from the client are copied into the
appropriate directories. If necessary
.BR pftp
creates new directories within the current directory, i.e.  the
directory where the server was started from. If only the client is
started with this option, all files sent by the client are copied into
the current directory.  For security reasons the server does not save
files in upper directories, e.g. a `/', or `..'  at the beginning of a
file name is just ignored.  Also combinations of such are ignored.
.TP
.I "\-s"
TCP: Always skip existing files.  UDP: Display on the fly the number
of bytes received by the datagrams. (Server option only)
.TP
.I "\-SNUM"
Using UDP based data transfer used to drop every NUMth datagram.  It
is meant to test the stability of the application on the server side.
On the Linux Operating System you can interactively increase or
decrease the value by typing `h' respectively `b'.  Typing `0'
means that no datagram will be dropped.
.TP
.I "\-T[NUM]"
Perform a net performance test.  NUM is the number of bytes send
during the test.  You must adjust the input buffer size with
`-b[NUM]'.  You can also set the net buffer size (see `-B[NUM]'), the
datagram priority (see `-P[NUM]'), and the bandwidth (see `-w[NUM]').
For a UDP based test you cannot set the net buffer size, though.  But
you can adjust the payload length with `-u[NUM]'.
.TP
.I "\-u[NUM]"
Use UDP as data transfer protocol.  NUM is the payload length, i.e.
the size of the string sent at once at a time.  The default size is
1472.  You cannot combine this option with `-B', `-d', `-f', and `-i'.
.sp
On the client side you can send data and files as if using normal tcp
connections.  Be advised to set the bandwidth.  On the Linux Operating
System you can interactively increase or decrease the bandwidth by
typing `=' to increase it by 64 bytes or `.' to increase by one byte
respectively `-' to decrease it by 64 bytes or `,' to decrease by one
byte, and interactively drop datagrams periodically by typing `h'
respectively `b'.  Type `0' to stop dropping of datagrams.  This is
meant to test your applications on the server side.  You can stop and
continue sending datagrams by typing space.  The datagrams are
sent without any further protocol header--just UDP.  Thus you can use
the client to send data to any program that is able to receive
datagrams via UDP.  Likewise
.BR pftp 's
server can be used to receive any data via UDP, i.e.  the server does
not care if datagrams are lost.
.sp
You can also set the string length to be received at once by NUM.  The
default size is 1472. Since the mechanism is meant to send AUDIO and VIDEO
streams, all data received is written to standard output.    On the Linux
Operating System you can interactively turn on and off of displaying the
number of bytes received by typing `s' (you will need a fast terminal to
display on the fly the number of bytes received).
.TP
.I "\-v"
Ouputs set buffer sizes and the bandwidth.
.TP
.I "\-w[NUM]"
Sets bandwidth in bytes per second specified by `NUM' or if `NUM' is
omitted by the variable
.IR PFTPBANDWID .
UDP: On the Linux Operating System this value can be interactively
changed by typing `=' respectively `-'.  (Client option only)
.TP
.I "\-W"
Displays the warranty.
.TP
.I "\-x"
Lets the server exit after the first connection. (Server option only)
.TP
.I "hotsname"
hostname may look like a host name list entry (see
.BR RESOURCES )
without the following port number.
.BR pftp
contacts the server started by inetd if a user name is given on
command line, i.e. the port number is set to 26.  If a user name
and a password is included option `-i' is implied.  If a user name
is included option `-n' respectively `-i' is implied.  Thus you
don't need to specify option `-n' or `-i'.
.PP
.SS EXAMPLES
In order to send two files start the server with a port number at
your choice at the destination host (port numbers between 1025 and
32768 are always legal unless they are in use\-\-then simply choose
another port number):
.sp
.RS +.5i
pftp 1234
.RE
.sp
Then start the client with the same port number at the origin host:
.sp
.RS +.5i
pftp 1234 destinationhost file1 file2
.RE
.sp
The server is waiting for connections until you quit it by typing `q'
(Linux) or `^C' (other Systems).
.PP
Now we want to copy the current directory including all subdirectories.
Start the server at the destination host with option `-r':
.sp
.RS +.5i
pftp 1234 -r
.RE
.sp
And analogeously start the client with the same option:
.sp
.RS +.5i
pftp 1234 -r destinationhost .
.RE
.sp
I suggest to let pftp create the file `.pftprc' to start
.BR pftp
with a default port number. See section
.BR RESOURCES
for further details.  If you start pftp without having a resource file
and you use options, or omit some, that could also be looked up in this
file, pftp will ask you if you want it to create a resource file.
.sp
To send data from standard input using the default port number  start
the server with option `-' and redirect the standard output wherever
you want to:
.sp
.RS +.5i
pftp - > file
.RE
.sp
The client is started as usual but this time with option `-':
.sp
.RS +.5i
pftp - destinationhost_or_host_number < file
.RE
.sp
Imagine you want to send files to a pftp server started by inetd and
upload the files in the directory `$HOME/misc' where `$HOME' is the
remote user's home directory.  If the remote host name is for example
listed in your host name list as number one you may want to use the
following
.sp
.RS +.5i
pftp -i=misc -1 files
.RE
.sp
If your host name list entry does not contain the remote user's login
name and maybe the password you will be asked for login name and
password.
.sp
Now lets send data to a friend of whom you have no password.  The
destination host is listed in your host name list as number 7.  Further
more you want to use a filter program for the connection and also send not
merely files but also directories.  Thus all you have to type is 
.sp
.RS +.5i
pftp -frn -7 data
.RE
.sp
where data is files and directories.  In this case the first filter
listed in your filter variable will be used which is the opposite filter
program of the other user's first filter program.

Now let's send directory `dir' to another user recursively.
The following implies `-n':
.sp
.RS +.5i
pftp -r user@remote_host_name dir
.RE
.sp
Some programs are able to read data from standard input.  Assuming
there is a huge file on a remote server we just want to read in by
such a program you can do the following on the program's server side:
.sp
.RS +.5i
pftp -xu | program -
.RE
.sp
(Keep in mind that when sending datagrams the program reading from
standard input is in charge if datagrams are lost.  If the program is
not able to handle incomplete data you need to use TCP based data
transfer: exchange `u' with `pp' for example on the server side and
just drop the `u' on the client side.)  And on the client side with a
bandwidth of about 169 KBytes:
.sp
.RS +.5i
pftp -uw173056 remote_host_name files
.RE
.sp
That is the way to use UDP based data tansfer with pftp.  You might
welcome that when omitting the `x' the server keeps running without
closing standard output.  Thus if the `program' supports it you can
let another client connecting the server and sending its data without
ever restarting the server.

Now let's do the latter example for the multicasted case:  Assuming
we want to use multicast group 225.0.0.27 and keep our trafic within our
local subnet:
.sp
.RS +.5i
pftp -xmg 225.0.0.27 | program -
.RE
.sp
And on the client side with a bandwidth of about 169 KBytes:
.sp
.RS +.5i
pftp -mw173056 225.0.0.27 files
.RE
.sp
.sp
.SH RESOURCES
There are two resource files
.BR pftp
may read in.  The system resource file `/etc/pftp.conf' is read in when
pftp is started as a server by inetd or if started as a daemon by root.
The user's resource file `~/.pftprc' is read otherwise.  Both files have
the following format:  At first all needed variables have to be specified
and at the end of the file goes the host name list.  Host names may be
followed by a port number (on the same line).  If no port number is given
the default one set with
.IR PFTPPORT
is used.
Variables are set in the resource file like the following:
.sp
.RS +.5i
.ta 0.5i 1.0i
.nf
PFTPPORT 1234
.fi
.RE
.sp
A host name list entry may look like one of these:
.sp
.RS +1i
.ta 0.5i 1.0i
.nf
username:passwd@hostname port
username:passwd@hostname
username@hostname port
username@hostname
hostname port
hostname
.fi
.RE
.sp
username is the name of the remote user if you send data to the daemon or
to the server started by inetd.  passwd is remote user's password.  If
you send data to the normal server username and passwd are ignored. Of
course the password is not shown if
.BR pftp
was started with `-l'.  Empty lines and all comments between a `#' and
the end of a line are ignored.
.sp
.SH ENVIRONMENT
Variables denoted with `<*>' may also be set as environment variables.
Command line settings have highest priority; environment variables have
higher priority than variables specified in the resource file.
.TP
.I PFTPBANDWID <*>
Holds value of bandwidth (see `-w') in bytes per second.  By default
.BR pftp
sends as fast
as possible.
.TP
.I PFTPCFILTER and PFTPSFILTER <*>
If on the client side variable
.IR PFTPCFILTER
and on the server side variable
.IR PFTPSFILTER
hold names of filter programs with possible options the filters will
be used if `-f' is given on command line.  The variables may hold
several filters.  All filter programs have to be seperated by a colon.
You may choose a specific filter program with `-fn' where n is the
number of the filter program.  The first filter program has number 1.
If n is not given the first filter program will be used.  In order to
list all client filters set n to C, to list all server filters set n
to S.
Technically speeking:
.BR pftp
send its data right into the standard input of the filter program.
The standard output of the filter program on the client side is
directly, i.e. via the network,  connected to the standard input of
the filter program on the server side.  On the server side
.BR pftp
reads the data right from the standard ouput of the filter program.
Thus keep in mind that the filter on the client side is just the
opposite of the filter on the server side!
.TP
.I PFTPCLIENTS <*>
May hold all client host names that are accepted.  The names are
seperated by spaces.  So if `-c' follows no host name that variable is
read instead.  Of course someone might crack your name server and fake
the host names.  But since
.BR pftp's
server does not create files or directories in upper directories no
user should have a real interest to do so.  For security reasons you
may choose an encryption filter for the connection with option `-fn'.
The special host name `.unkown_host' allows every remote host to
connect if remote host's host name cannot be resolved or the name
server is unreachable.  Alternatively you may specify the remote host
names ip address as well.
.TP
.I PFTPEDITOR <*>
Holds the name of the editor.  The default editor is `vi'.
.TP
.I PFTPLOG <*>
If the environment variable
.IR PFTPLOG
is set to the absolute path of an error file, the client logs all error
messages that occur while sending files in the error file.  Since the
client does not exit on errors concerning unreadable or empty files and
directories, it might be useful to log the error messages.  So you can
send these mostly few files afterwards.
.TP
.I PFTPLOGFILE
If set to 1 and
.IR PFTPSLOG
is set logs also all file and directory names being transfered.
.TP
.I PFTPNETBUF <*>
Sets the maximum net buffer size in bytes (see `-B').
.TP
.I PFTPNOROOT
If set to 0 allows root `login' when
.BR pftp
is running as a daemon with root privileges (see `-d') or was started by
inetd (see `-i').  The default setting is 1.
.TP
.I PFTPPAGER <*>
Holds the name of the pager.  The default pager is
.BR pftp's
internal pager.
.TP
.I PFTPPASS
If set to an encrypted normal Unix password (MD5) it is used instead of
the user's system password (see `-e').  If your system has shadow
password and you want to run the daemon without root privileges you do
need this variable to be set.  You may set it to `*' in order to deny
uploading at all.
.TP
.I PFTPPORT
Holds the default port number.
.TP
.I PFTPRECEIVE
Holds the absolute path of an upload directory for files and directories
sent by other users (see `-n').  If this variable is unset no other user
will be allowed to upload files and directories.
.TP
.I PFTPSLOG <*>
If set to the absolute path of a log file the daemon as well as
the server started by inetd log all connections.
.TP
.I PFTPSORTBY
Determines sorting order within the pfm.  May be set to `a' for
alphabetical (this is the default setting), `s' for size, and `t' for
time.
.TP
.I PFTPUPLIMIT
Sets a limit in kilo bytes to the upload directory (see
.BR PFTPRECEIVE ).
The size defaults to 2048 kilo bytes.
.SH AUTHOR
Ben Schluricke
.SH DEDICATION
This program is dedicated to
.BR "Heather O'Rourke" .
.SH "SEE ALSO"
rcp(1), scp(1)
.SH BUGS
Setting the net buffer size to zero may crash older systems.  So you
should use a buffer size of zero for test purposes only.  Most newer
systems set a buffer size of zero to one by default.
.sp
You may see the latest bug report and the latest version of pftp at
`http://star.trek.org/~pftp'.

If you find any bug, please drop me an e-mail.
.sp
.RS +1.2i
pftp@star.trek.org
.RE
.sp
Every comment via e-mail will be appreciated!
